//Master Lenman's XOR Encryption 2.0 - A Polecatsoft program
//This program encrypts and decrypts files using an extremely simple algorithm
//Same program for encryption and decryption

#include <string>
#include <fstream>
#include <iostream>

#include "XorEncryption.h"
#include "main.h"

using namespace std;

int XorEncryption(int argc, char **argv)
{
	//for() counter variable
	int i;

	//Check if enough parameters are given
	cout << "You are now running the MLXE function of MLSS.\n" << endl;
	if(argc < 3)
	{
		cout << "Possible options (explanations are in brackets):\n"
			<< "-i inputfile (File that will be encrypted/decrypted)\n"
			<< "-o outputfile (File that will contain the encrypted/decrypted content; default: output)\n"
			<< "-p password (the password that will be used for encryption)\n"
			<< "-m (is slower but doesn't use much memory)\n";

		cout << "Non-optional options: -i -p" << endl;
		return 0;
	}

	//File names
	string infilename;
	string outfilename;
	//An entity of an encryptClass
	encryptClass *encrypt = 0;
	bool memSaveMode = false;
	for(i = 2; i < argc; ++i)
	{
		string temp(argv[i]);
		bool missingArgument = false;
		if(temp == string("-p"))
		{
			if(++i < argc)
			{
				if(!string(argv[i]).empty())
					encrypt = new encryptClass(argv[i]);
				continue;
			}
			missingArgument = true;
		}
		else if(temp == string("-i"))
		{
			if(++i < argc)
			{
				infilename = argv[i];
				continue;
			}
			missingArgument = true;
		}
		else if(temp == string("-o"))
		{
			if(++i < argc)
			{
				outfilename = argv[i];
				continue;
			}
			missingArgument = true;
		}
		else if(temp == string("-m"))
		{
			memSaveMode = true;
			cout << "Low memory mode active!" << endl;
			continue;
		}
		if(missingArgument)
			cout << "The option " << temp << " is missing an argument!";
		else
			cout << "Unknown option \"" << temp << "\"!";
		cout << endl;
		return 0;
	}

	if(infilename.empty())
	{
		cout << "Missing the non-optional option -i!" << endl;
		return 0;
	}
	if(!encrypt)
	{
		cout << "Missing the non-optional option -p!" << endl;
		return 0;
	}
	if(outfilename.empty())
		outfilename = "output";

	ifstream infile(infilename.c_str(), ios::binary);
	if(infile.fail())
	{
		cout << "Couldn't open " << infilename << "!" << endl;
		return 0;
	}
	ofstream outfile(outfilename.c_str(), ios::binary);

	cout << "Data from the file '" << infilename << "' will be encrypted/decrypted\n"
		<< "and stored in the file '" << outfilename << "'.\n";
	cout << "Setup was finished, beginning to process data..." << endl;

	unsigned int infilesize = getFileSize(infilename);
	if(!memSaveMode)
	{
		unsigned char *dataArray = new unsigned char[infilesize];
		infile.read(reinterpret_cast<char*>(dataArray), infilesize);
		encrypt->exe(dataArray, infilesize);
		outfile.write(reinterpret_cast<char*>(dataArray), infilesize);
		delete [] dataArray;
	}
	else
	{
		unsigned char temp;
		for(unsigned int j = 0; j < infilesize; ++j)
		{
			infile.read(reinterpret_cast<char*>(&temp), 1);
			encrypt->exe(temp);
			outfile.write(reinterpret_cast<char*>(&temp), 1);
		}
	}
	infile.close();
	outfile.close();
	cout << "All data was processed." << endl;

	return 0;
}

encryptClass::encryptClass()
{
	resetPos();
}

encryptClass::encryptClass(string key)
{
	resetPos();
	setKey(key);
}

void encryptClass::setKey(string newKey)
{
	key = newKey;
}

void encryptClass::resetPos()
{
	pos = 0;
}

void encryptClass::exe(unsigned char &byte)
{
	byte ^= key[pos++];
	if(pos == key.size())
		resetPos();
}

void encryptClass::exe(unsigned char *byte, int size)
{
	for(int i = 0; i < size; ++i)
		exe(byte[i]);
}
